/** @file sp/spAudioLib.h */

#ifndef __SPAUDIOLIB_H
#define __SPAUDIOLIB_H

/**
@~english
@mainpage %spAudio - Audio I/O Library 
This library is %spAudio, audio I/O library which is a part of spLibs. %spAudio has
the following features.
 - Support for Windows, Macintosh, and Linux, Android, and iOS.
 - Support for I/O functions of WAV and AIFF files.
 - Support for plug-ins to expand file I/O operations.
 - Support for audio I/O functions (also support for full duplex and real time I/O) 
@example playsin.c @example rec.c @example iotest.c @example driver.c @example pluginlist.c
 */

#include <sp/spWave.h>
#include <sp/spID3.h>
#include <sp/spMp4.h>
#include <sp/spAudio.h>
#include <sp/spOutputPlugin.h>
#include <sp/spInputPlugin.h>
#include <sp/spRwPlugin.h>

#endif /* __SPAUDIOLIB_H */
