/*
 *        spMp4.h
 *        
 *        **** UNOFFICIAL VERSION, DON'T USE THIS API ****
 */

#ifndef __SPMP4_H
#define __SPMP4_H

#include <time.h>

#include <sp/spChunk.h>
#include <sp/spWave.h>

#ifdef __cplusplus
extern "C" {
#endif

#define SP_MP4_BOX_MIN_ENTRY_ALLOC_COUNT 4
    
#define spMp4BoxSize spChunkSize

#define SP_MP4_META_DATA_TYPE_INDICATOR_UTF8 1
#define SP_MP4_META_DATA_TYPE_INDICATOR_UTF16 2
#define SP_MP4_META_DATA_TYPE_INDICATOR_SJIS 3
#define SP_MP4_META_DATA_TYPE_INDICATOR_UTF8_SORT 4
#define SP_MP4_META_DATA_TYPE_INDICATOR_UTF16_SORT 5
#define SP_MP4_META_DATA_TYPE_INDICATOR_JPEG 13
#define SP_MP4_META_DATA_TYPE_INDICATOR_PNG 14
#define SP_MP4_META_DATA_TYPE_INDICATOR_BE_SIGNED_INT 21
#define SP_MP4_META_DATA_TYPE_INDICATOR_BE_UNSIGNED_INT 22
#define SP_MP4_META_DATA_TYPE_INDICATOR_BE_FLOAT 23
#define SP_MP4_META_DATA_TYPE_INDICATOR_BE_DOUBLE 24
#define SP_MP4_META_DATA_TYPE_INDICATOR_BMP 27
#define SP_MP4_META_DATA_TYPE_INDICATOR_QT_METADATA 28

#define SP_MP4_META_DATA_TYPE_TITLE "\251nam"
#define SP_MP4_META_DATA_TYPE_ARTIST "\251ART"
#define SP_MP4_META_DATA_TYPE_ALBUM_ARTIST "aART"
#define SP_MP4_META_DATA_TYPE_ALBUM "\251alb"
#define SP_MP4_META_DATA_TYPE_COMPOSER "\251wrt"
#define SP_MP4_META_DATA_TYPE_GENRE "\251gen"
#define SP_MP4_META_DATA_TYPE_RELEASE "\251day"
#define SP_MP4_META_DATA_TYPE_SOFTWARE "\251too"
#define SP_MP4_META_DATA_TYPE_COPYRIGHT "cprt"
#define SP_MP4_META_DATA_TYPE_COMMENT "\251cmt"
#define SP_MP4_META_DATA_TYPE_TITLE_YOMI "sonm"
#define SP_MP4_META_DATA_TYPE_ARTIST_YOMI "soar"
#define SP_MP4_META_DATA_TYPE_ALBUM_ARTIST_YOMI "soaa"
#define SP_MP4_META_DATA_TYPE_ALBUM_YOMI "soal"
#define SP_MP4_META_DATA_TYPE_COMPOSER_YOMI "soco"
#define SP_MP4_META_DATA_TYPE_TRACK "trkn"
#define SP_MP4_META_DATA_TYPE_DISC "disc"
#define SP_MP4_META_DATA_TYPE_TEMPO "tmpo"
#define SP_MP4_META_DATA_TYPE_COMPILATION "cpil"
#define SP_MP4_META_DATA_TYPE_GAPLESS "pgap"
    
typedef struct _spMp4BoxHeader {
    char type[4];
    unsigned long size;
    spMp4BoxSize largesize;
    unsigned char version;
    unsigned char flags[3];
    spBool fullbox_flag;

    spMp4BoxSize marginsize;        /* internal */
} spMp4BoxHeader;
    
typedef struct _spMp4Box {
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;
    
    spFileOffset offset;
    
    spMp4BoxHeader header;
} spMp4Box;
    
typedef struct _spMp4ULongOnlyBox { 
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;

    unsigned long value;
} spMp4ULongOnlyBox;

typedef struct _spMp4DataOnlyBox { 
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;
    
    char *data;
} spMp4DataOnlyBox;

typedef struct _spMp4MetaDataValueBox { /* 'data' */
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;
    
    unsigned long type_indicator;
    unsigned short country;
    unsigned short language;
    char *value;
} spMp4MetaDataValueBox;

typedef struct _spMp4UserDataStringBox { 
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;
    
    unsigned short size;
    unsigned short language;
    char *string;
} spMp4UserDataStringBox;

typedef struct _spMp4FileTypeBox { /* 'ftyp' */
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;
    
    spFileOffset offset;
    
    spMp4BoxHeader header;
    
    char major_brand[4];
    long minor_version;

    long nbrands;
    char *compatible_brands;
} spMp4FileTypeBox;

typedef struct _spMp4MovieHeaderBox { /* 'mvhd' */
    struct _spMp4MovieBox *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;
    
    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */

    union {
        struct {
            char creation_time[8];
            char modification_time[8];
            unsigned long timescale;
            char duration[8];
        } version1;

        struct {
            unsigned long creation_time;
            unsigned long modification_time;
            unsigned long timescale;
            unsigned long duration;
        } version0;
    } u;
    
    long rate;
    short volume;
    short reserved;
    unsigned long reserved2[2];
    long matrix[9];
    unsigned long pre_defined[6];
    unsigned long next_track_id;
    
} spMp4MovieHeaderBox;

typedef struct _spMp4TrackHeaderBox { /* 'tkhd' */
    struct _spMp4TrackBox *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;
    
    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    union {
        struct {
            char creation_time[8];
            char modification_time[8];
            unsigned long track_id;
            unsigned long reserved;
            char duration[8];
        } version1;

        struct {
            unsigned long creation_time;
            unsigned long modification_time;
            unsigned long track_id;
            unsigned long reserved;
            unsigned long duration;
        } version0;
    } u;
    
    unsigned long reserved2[2];
    short layer;
    short alternate_group;
    short volume;
    unsigned short reserved3;
    long matrix[9];

    unsigned long width;
    unsigned long height;
} spMp4TrackHeaderBox;

typedef struct _spMp4MediaHeaderBox { /* 'mdhd' */
    struct _spMp4MediaBox *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    union {
        struct {
            char creation_time[8];
            char modification_time[8];
            unsigned long timescale;
            char duration[8];
        } version1;

        struct {
            unsigned long creation_time;
            unsigned long modification_time;
            unsigned long timescale;
            unsigned long duration;
        } version0;
    } u;

    unsigned short language;
    unsigned short quality;
} spMp4MediaHeaderBox;

typedef struct _spMp4UserDataBox { /* 'udta' */
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;
    
    struct _spMp4MetaBox *meta;        /* optional */
    spMp4Box *cprt;                /* optional */
    spMp4Box *tsel;                /* optional */
    spMp4Box *hinf;                /* optional */
    spMp4Box *hnti;                /* optional */
} spMp4UserDataBox;
    
typedef struct _spMp4LanguageList {
    unsigned short language_count;
    short *language;
} spMp4LanguageList;
    
typedef struct _spMp4LanguageListBox { /* 'lang' */
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    unsigned long alloc_count;        /* internal */
    unsigned long entry_count;
    spMp4LanguageList *language_lists;
} spMp4LanguageListBox;
    
typedef struct _spMp4CountryList {
    unsigned short country_count;
    char *country;
} spMp4CountryList;
    
typedef struct _spMp4CountryListBox { /* 'ctry' */
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    unsigned long alloc_count;        /* internal */
    unsigned long entry_count;
    spMp4CountryList *country_lists;
} spMp4CountryListBox;
    
typedef struct _spMp4KeyEntry {
    unsigned long size;
    char name_space[4];
    char *value;
} spMp4KeyEntry;
    
typedef struct _spMp4KeysBox { /* 'keys' */
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    unsigned long alloc_count;        /* internal */
    unsigned long entry_count;
    spMp4KeyEntry *keys;
} spMp4KeysBox;
    
typedef struct _spMp4HandlerReferenceBox { /* 'hdlr' */
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    unsigned long pre_defined;
    char handler_type[4];
    
    unsigned long reserved[3];        /* reserved[0]: sometimes 'appl' */

    char *name;
} spMp4HandlerReferenceBox;
    
typedef struct _spMp4VideoMediaHeaderBox { /* 'vmhd' */
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;
    
    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    unsigned short graphicsmode;
    unsigned short opcolor[3];
} spMp4VideoMediaHeaderBox;
    
typedef struct _spMp4SoundMediaHeaderBox { /* 'smhd' */
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    unsigned short balance;        /* 8.8 format; actual balance = (double)balance / 256.0 */
    unsigned short reserved;
} spMp4SoundMediaHeaderBox;
    
typedef struct _spMp4HintMediaHeaderBox { /* 'hmhd' */
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;
    
    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    unsigned short maxPDUSize;
    unsigned short avgPDUSize;
    unsigned long maxBitRate;
    unsigned long avgBitRate;
    unsigned long reserved;
} spMp4HintMediaHeaderBox;
    
typedef struct _spMp4NullMediaHeaderBox { /* 'nmhd' */
    struct _spMp4Box *parent;    
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;
    
    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
} spMp4NullMediaHeaderBox;
    
typedef struct _spMp4DataSampleEntry {
    char *data;
} spMp4DataSampleEntry;
    
typedef struct _spMp4RtpHintSampleEntry { /* 'rtp ' */
    unsigned short hint_track_version;
    unsigned short highest_compatible_version;
    unsigned long max_packet_size;
    
    spMp4ULongOnlyBox *tims;        /* optional */
    spMp4ULongOnlyBox *tsro;        /* optional */
    spMp4ULongOnlyBox *snro;        /* optional */
} spMp4RtpHintSampleEntry;
    
typedef struct _spMp4BitRateBox { /* 'btrt' */
    spMp4BoxHeader btrt;

    unsigned long bufferSizeDB;
    unsigned long maxBitRate;
    unsigned long avgBitRate;
} spMp4BitRateBox;
    
typedef struct _spMp4XMLMetaDataSampleEntry { /* 'metx' */
    char content_encoding[256];
    char name_space[256];
    char schema_location[256];

    spMp4BitRateBox bitRate;        /* optional */
} spMp4XMLMetaDataSampleEntry;
    
typedef struct _spMp4TextMetaDataSampleEntry { /* 'mett' */
    char content_encoding[256];
    char mime_format[256];

    spMp4BitRateBox bitRate;        /* optional */
} spMp4TextMetaDataSampleEntry;
    
typedef struct _spMp4SampleScaleBox { /* 'stsl' */
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;
    
    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    unsigned char flag;
    unsigned char scale_method;
    short display_center_x;
    short display_center_y;
} spMp4SampleScaleBox;
    
typedef struct _spMp4PixelAspectRatioBox { /* 'pasp' */
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;
    
    spFileOffset offset;
    
    spMp4BoxHeader header;
    
    unsigned long hSpacing;
    unsigned long vSpacing;
} spMp4PixelAspectRatioBox;
    
typedef struct _spMp4CleanApertureBox { /* 'clap' */
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;
    
    spFileOffset offset;
    
    spMp4BoxHeader header;
    
    unsigned long cleanApertureWidthN;
    unsigned long cleanApertureWidthD;

    unsigned long cleanApertureHeightN;
    unsigned long cleanApertureHeightD;
    
    unsigned long horizOffN;
    unsigned long horizOffD;

    unsigned long vertOffN;
    unsigned long vertOffD;
} spMp4CleanApertureBox;
    
typedef struct _spMp4ColorParameterBox { /* 'colr' */
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;
    
    char type[4];
    /* type == nclc case */
    short primaries_index;
    short transfer_function_index;
    short matrix_index;

    /* type != nclc case */
    char *data;
} spMp4ColorParameterBox;
    
typedef struct _spMp4VisualSampleEntry { /* 'vide' */
    unsigned short version;
    unsigned short revision;
    unsigned long vendor;
    unsigned long temporal_quality;
    unsigned long spatial_quality;
    unsigned short width;
    unsigned short height;
    unsigned long horizresolution; /* pixels per inch */
    unsigned long vertresolution; /* pixels per inch */
    unsigned long reserved2;
    unsigned short frame_count;
    char compressorname[32];    /* compressorname[0]: string length */
    unsigned short depth;
    short color_table_id; /*short pre_defined3;*/

    spMp4ULongOnlyBox *gama;        /* optional */
    spMp4DataOnlyBox *fiel;         /* optional */
    spMp4DataOnlyBox *esds;         /* optional */
    spMp4CleanApertureBox *clap;    /* optional */
    spMp4ColorParameterBox *colr;   /* optional */
    spMp4PixelAspectRatioBox *pasp; /* optional */
    spMp4SampleScaleBox *stsl;      /* optional */
    spMp4DataOnlyBox *avcC;         /* optional */
    spMp4DataOnlyBox *uuid;         /* optional */
    spMp4DataOnlyBox *mjqt;         /* optional */
    spMp4DataOnlyBox *mjht;         /* optional */
} spMp4VisualSampleEntry;
    
typedef struct _spMp4AudioSampleEntry { /* 'soun' */
    unsigned short version;
    unsigned short revision;
    unsigned long vendor;
    unsigned short channelcount;
    unsigned short samplesize;
    short compression_id;
    unsigned short reserved;
    unsigned long samplerate;        /* 16.16 format; actual rate = (double)samplerate / 65536.0 */

    unsigned long samples_per_packet;
    unsigned long bytes_per_packet;
    unsigned long bytes_per_frame;
    unsigned long bytes_per_sample;

    spMp4DataOnlyBox *frma;        /* optional */
    spMp4DataOnlyBox *esds;        /* optional */
    spMp4DataOnlyBox *alac;        /* optional */
} spMp4AudioSampleEntry;
    
typedef struct _spMp4AudioV2SampleEntry { /* 'soun' */
    unsigned short version;        /* 2 */
    unsigned short revision;       /* 0 */
    unsigned long vendor;          /* 0 */
    unsigned short always3;        /* 3 */
    unsigned short always16;       /* 16 */
    short alwaysMinus2;            /* -2 */
    unsigned short always0;        /* 0 */
    unsigned long always65536;     /* 65536 */

    unsigned long sizeOfStructOnly;
    double audioSampleRate;
    unsigned long numAudioChannels;
    unsigned long always7F000000;  /* 0x7F000000 */
    unsigned long constBitsPerChannels;
    unsigned long formatSpecificFlags;
    unsigned long constBytesPerAudioPacket;
    unsigned long constLPCMFramesPerAudioPacket;

    spMp4DataOnlyBox *frma;        /* optional */
    spMp4DataOnlyBox *esds;        /* optional */
    spMp4DataOnlyBox *alac;        /* optional */
} spMp4AudioV2SampleEntry;

typedef struct _spMp4TimecodeSampleEntry { /* 'tmcd' */
    unsigned long reserved;        /* 0 */
    unsigned long flags;
    unsigned long timescale;
    unsigned long frame_duration;
    unsigned char number_of_frames;
    unsigned char reserved2;       /* 0 */

    spMp4DataOnlyBox *name; /* optional */
} spMp4TimecodeSampleEntry;

typedef struct _spMp4SampleEntryBox {
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;
    
    unsigned char reserved[6];
    unsigned short data_reference_index; /* 1-based index */

    union {
        spMp4AudioSampleEntry soun;
        spMp4VisualSampleEntry vide;
        spMp4DataSampleEntry hint;
        spMp4RtpHintSampleEntry rtp;
        spMp4XMLMetaDataSampleEntry metx;
        spMp4TextMetaDataSampleEntry mett;
        spMp4TimecodeSampleEntry tmcd;
        spMp4DataSampleEntry data;
    } u;
} spMp4SampleEntryBox;
    
typedef struct _spMp4TimeToSampleEntry {
    unsigned long sample_count;
    unsigned long sample_delta;
} spMp4TimeToSampleEntry;
    
typedef struct _spMp4TimeToSampleBox { /* 'stts' */
    struct _spMp4SampleTableBox *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    unsigned long alloc_count;        /* internal */
    unsigned long entry_count;
    spMp4TimeToSampleEntry *entries;

    unsigned long total_sample;        /* internal */
#ifdef SP_SUPPORT_64BIT_INT
    spLong64 total_duration;        /* internal */
#else
    char total_duration[8];        /* internal */
#endif
} spMp4TimeToSampleBox;
    
typedef struct _spMp4SampleToChunkEntry {
    unsigned long first_chunk;
    unsigned long samples_per_chunk;
    unsigned long sample_description_index;
} spMp4SampleToChunkEntry;
    
typedef struct _spMp4SampleToChunkBox { /* 'stsc' */
    struct _spMp4SampleTableBox *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    unsigned long alloc_count;        /* internal */
    unsigned long entry_count;
    spMp4SampleToChunkEntry *entries;
} spMp4SampleToChunkBox;
    
typedef struct _spMp4CompositionOffsetEntry {
    unsigned long sample_count;
    unsigned long sample_offset;
} spMp4CompositionOffsetEntry;

typedef struct _spMp4CompositionOffsetBox { /* 'ctts' */
    struct _spMp4SampleTableBox *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    unsigned long alloc_count;        /* internal */
    unsigned long entry_count;
    spMp4CompositionOffsetEntry *entries;
} spMp4CompositionOffsetBox;

typedef struct _spMp4ChunkOffsetBox { /* 'stco' */
    struct _spMp4SampleTableBox *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;
    
    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    unsigned long alloc_count;        /* internal */
    unsigned long entry_count;
    spFileOffset *chunk_offset;
} spMp4ChunkOffsetBox;
    
typedef struct _spMp4SyncSampleBox { /* 'stss' */
    struct _spMp4SampleTableBox *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    unsigned long alloc_count;        /* internal */
    unsigned long entry_count;
    unsigned long *sample_number;
} spMp4SyncSampleBox;
    
typedef struct _spMp4ShadowSyncSampleEntry {
    unsigned long shadowed_sample_number;
    unsigned long sync_sample_number;
} spMp4ShadowSyncSampleEntry;
    
typedef struct _spMp4ShadowSyncSampleBox { /* 'stsh' */
    struct _spMp4SampleTableBox *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    unsigned long alloc_count;        /* internal */
    unsigned long entry_count;
    spMp4ShadowSyncSampleEntry *entries;
} spMp4ShadowSyncSampleBox;
    
typedef struct _spMp4SampleDescriptionBox { /* 'stsd' */
    struct _spMp4SampleTableBox *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;
    
    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    unsigned long alloc_count;        /* internal */
    unsigned long entry_count;
    spMp4SampleEntryBox *entries;
    unsigned long end_marker_size;    /* internal */
} spMp4SampleDescriptionBox;
    
typedef struct _spMp4SampleDependencyTypeBox { /* 'sdtp' */
    struct _spMp4SampleTableBox *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    unsigned long entry_count;
    unsigned char *entries;
} spMp4SampleDependencyTypeBox;
    
typedef struct _spMp4DegradationPriorityBox { /* 'stdp' */
    struct _spMp4SampleTableBox *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;
    
    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    unsigned long entry_count;
    unsigned short *priority;
} spMp4DegradationPriorityBox;
    
typedef struct _spMp4SampleSizeBox { /* 'stsz' or 'stz2' */
    struct _spMp4SampleTableBox *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;
    
    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    unsigned long sample_size;        /* 'stsz' only */
    unsigned char field_size;        /* 'stz2' only */
    
    unsigned long alloc_count;        /* internal */
    unsigned long entry_count;
    
    unsigned long *entries;
} spMp4SampleSizeBox;
    
typedef struct _spMp4SampleTableBox { /* 'stbl' */
    struct _spMp4MediaInformationBox *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;
    
    spMp4SampleDescriptionBox *stsd;
    spMp4TimeToSampleBox *stts;
    spMp4CompositionOffsetBox *ctts; /* optional */
    spMp4SampleToChunkBox *stsc;
    
    spMp4SampleSizeBox *stsz;        /* or 'stz2' */
    spMp4ChunkOffsetBox *stco;
    spMp4SyncSampleBox *stss; /* optional */
    spMp4ShadowSyncSampleBox *stsh; /* optional */
    spMp4DegradationPriorityBox *stdp; /* optional */
    spMp4SampleDependencyTypeBox *sdtp; /* optional */
} spMp4SampleTableBox;
    
typedef struct _spMp4DataReferenceBox { /* 'dref' */
    struct _spMp4DataInformationBox *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;        /* full header */
    
    spMp4BoxHeader header;

    unsigned long entry_count;
} spMp4DataReferenceBox;
    
typedef struct _spMp4DataInformationBox { /* 'dinf' */
    struct _spMp4MediaInformationBox *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;        /* full header */
    
    spMp4BoxHeader header;

    spMp4DataReferenceBox *dref;
} spMp4DataInformationBox;
    
typedef struct _spMp4MediaInformationBox { /* 'minf' */
    struct _spMp4MediaBox *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;
    
    spFileOffset offset;
    
    spMp4BoxHeader header;
    
    union {
        spMp4VideoMediaHeaderBox *vmhd;
        spMp4SoundMediaHeaderBox *smhd;
        spMp4HintMediaHeaderBox *hmhd;
        spMp4NullMediaHeaderBox *nmhd;
    } u;

    spMp4DataInformationBox *dinf;
    spMp4SampleTableBox *stbl;
    spMp4HandlerReferenceBox *hdlr; /* optional */
} spMp4MediaInformationBox;

typedef struct _spMp4MediaBox {        /* 'mdia' */
    struct _spMp4TrackBox *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;
    
    spMp4MediaHeaderBox *mdhd;
    
    spMp4HandlerReferenceBox *hdlr;
    spMp4MediaInformationBox *minf;
    spMp4UserDataBox *udta; /* optional */
} spMp4MediaBox;

typedef struct _spMp4TrackReferenceBox { /* 'tref' */
    struct _spMp4TrackBox *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;
    
    spFileOffset offset;
    
    spMp4BoxHeader header;
    
    spMp4BoxHeader reference_type;
    unsigned long *track_ids;
} spMp4TrackReferenceBox;
    
typedef struct _spMp4EditListEntryV0 {
    unsigned long segment_duration;
    long media_time;
    unsigned long media_rate;        /* 16.16 format */
} spMp4EditListEntryV0;
    
typedef struct _spMp4EditListEntryV1 {
#ifdef SP_SUPPORT_64BIT_INT
    spULong64 segment_duration;
    spLong64 media_time;
#else
    char segment_duration[8];
    char media_time[8];
#endif
    unsigned long media_rate;        /* 16.16 format */
} spMp4EditListEntryV1;
    
typedef struct _spMp4EditListBox { /* 'elst' */
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    unsigned long alloc_count;        /* internal */
    unsigned long entry_count;
    union {
        spMp4EditListEntryV0 *edit_list_table_v0;
        spMp4EditListEntryV1 *edit_list_table_v1;
    } u;
} spMp4EditListBox;
    
typedef struct _spMp4MetaBox { /* 'meta' */
    struct _spMp4Box *parent;
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;

    spFileOffset offset;
    
    spMp4BoxHeader header;        /* full header */
    
    spMp4HandlerReferenceBox *hdlr;
    spMp4Box *ilst;
    spMp4ULongOnlyBox *mhdr;        /* optional */
    spMp4KeysBox *keys;                /* optional */
    spMp4CountryListBox *ctry;        /* optional */
    spMp4LanguageListBox *lang;        /* optional */
} spMp4MetaBox;

typedef struct _spMp4TrackBox {        /* 'trak' */
    struct _spMp4MovieBox *parent; /* 'moov' */
    struct _spMp4Box *child;
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;
    
    spFileOffset offset;
    
    spMp4BoxHeader header;
    
    spMp4TrackHeaderBox *tkhd;
    
    spMp4DataOnlyBox *clip; /* optional */
    spMp4Box *matt; /* optional */
    spMp4Box *edts; /* optional */
    spMp4TrackReferenceBox *tref; /* optional */
    spMp4DataOnlyBox *load; /* optional */
    spMp4Box *imap; /* optional */
    
    spMp4MediaBox *mdia;
    spMp4UserDataBox *udta; /* optional */
} spMp4TrackBox;

typedef struct _spMp4MovieBox {        /* 'moov' */
    struct _spMp4Box *parent;
    struct _spMp4Box *child;        /* normally 'mvhd' */
    
    struct _spMp4Box *prev;
    struct _spMp4Box *next;
    
    spFileOffset offset;
    
    spMp4BoxHeader header;
    
    spMp4MovieHeaderBox *mvhd;
    spMp4TrackBox *trak;
    spMp4UserDataBox *udta; /* optional */
} spMp4MovieBox;

typedef struct _spMp4Header {
    struct _spMp4Box *parent;        /* NULL */
    struct _spMp4Box *child;        /* normally 'ftyp' */
    
    struct _spMp4Box *prev;        /* NULL */
    struct _spMp4Box *next;        /* NULL */

    spFileOffset offset;
    
    spMp4BoxHeader header;        /* dummy */
    
    spMp4FileTypeBox *ftyp;        /* first child */
    spMp4MovieBox *moov;
    struct _spMp4Box *mdat;
} spMp4Header;
    
typedef spMp4BoxSize (*spMp4BoxUpdateFunc)(spMp4Box *box, void *data);

extern unsigned short spGetMp4LangCode(const char *lang);
extern void spGetMp4LangStr(unsigned short code, char *lang, int lang_size);
    
extern spBool spEqMp4BoxType(spMp4Box *box, const char *type);
    
extern spMp4BoxSize spGetMp4BoxContentMarginSize(spMp4Box *box);
extern spBool spSetMp4BoxContentMarginSize(spMp4Box *box, spMp4BoxSize marginsize);
extern spBool spSetMp4BoxHeaderContentSize(spMp4BoxHeader *box_header, spMp4BoxSize size);
extern spBool spSetMp4BoxContentSize(spMp4Box *box, spMp4BoxSize size, spBool propagate_size);
extern spMp4BoxSize spGetMp4BoxHeaderContentSize(spMp4BoxHeader *box_header);
extern spMp4BoxSize spGetMp4BoxHeaderBoxSize(spMp4BoxHeader *box_header);
extern spMp4BoxSize spGetMp4BoxHeaderSize(spMp4Box *box);
    
extern spMp4BoxSize spGetMp4BoxSize(spMp4Box *box, char *string/* = char string[5] or NULL */);
extern spMp4BoxSize spGetMp4BoxContentSize(spMp4Box *box, char *string/* = char string[5] or NULL */);

extern spBool spGetMp4BoxHandleType(spMp4Box *box, char *type);

extern spMp4BoxSize spUpdateMp4ULongOnlyBox(spMp4ULongOnlyBox *ulobox, unsigned long value);
extern spMp4Box *spAppendMp4ULongOnlyBox(spMp4Box *parent, const char *type, unsigned long value);
    
extern spMp4BoxSize spUpdateMp4DataOnlyBox(spMp4DataOnlyBox *dobox, const char *data, spMp4BoxSize size, spBool propagate_size);
extern spMp4Box *spAppendMp4DataOnlyBox(spMp4Box *parent, const char *type, const char *data, spMp4BoxSize size);
    
extern spMp4MetaBox *spAppendMp4UserDataMetaBox(spMp4Box *parent, spMp4BoxSize meta_size, const char *handler_type, const char *handler_name);
    
extern spMp4BoxSize spUpdateMp4UserDataStringBox(spMp4UserDataStringBox *udsbox, short language, const char *string, spBool propagate_size);
extern spMp4Box *spAppendMp4UserDataStringBox(spMp4Box *parent, const char *type, short language, const char *string);

/* 'data' */
extern spMp4BoxSize spUpdateMp4MetaDataValueBox(spMp4MetaDataValueBox *databox,
                                                unsigned long type_indicator, unsigned short country, unsigned short language,
                                                const char *value, spMp4BoxSize value_size, spBool propagate_size);
extern spMp4MetaDataValueBox *spAppendMp4MetaDataValueBox(spMp4Box *parent, const char *type, unsigned long type_indicator,
                                                          unsigned short country, unsigned short language,
                                                          const char *value, spMp4BoxSize value_size);
extern spMp4MetaDataValueBox *spAppendMp4MetaDataUTF8String(spMp4MetaBox *meta, const char *type,
                                                            unsigned short country, unsigned short language, const char *utf8str);
extern spMp4MetaDataValueBox *spAppendMp4MetaDataUTF8StringFromLocaleCode(spMp4MetaBox *meta, const char *type,
                                                                          unsigned short country, unsigned short language, const unsigned char *str_in_locale);

extern spBool spParseMp4MetaDataUTF8StringToLocaleCode(spMp4MetaDataValueBox *databox, unsigned char *str_in_locale, long size);
extern char *xspParseMp4MetaDataUTF8StringToLocaleCode(spMp4MetaDataValueBox *databox);
extern const char *spGetMp4MetaDataUTF8String(spMp4MetaBox *meta, const char *type);
extern spBool spGetMp4MetaDataUTF8StringToLocaleCode(spMp4MetaBox *meta, const char *type, unsigned char *str_in_locale, long size);
extern char *xspGetMp4MetaDataUTF8StringToLocaleCode(spMp4MetaBox *meta, const char *type);
    
extern unsigned long spParseMp4MetaDataBESignedInt(spMp4MetaDataValueBox *databox, long *number);
extern unsigned long spParseMp4MetaDataBEUnsignedInt(spMp4MetaDataValueBox *databox, unsigned long *number);
extern spBool spGetMp4MetaDataTempo(spMp4MetaBox *meta, long *tempo);
extern spBool spGetMp4MetaDataBoolean(spMp4MetaBox *meta, const char *type, spBool *flag);
extern spBool spGetMp4MetaDataGapless(spMp4MetaBox *meta, spBool *flag);
extern spBool spGetMp4MetaDataCompilation(spMp4MetaBox *meta, spBool *flag);
extern spMp4MetaDataValueBox *spAppendMp4MetaDataBESignedInt(spMp4MetaBox *meta, const char *type, long number, unsigned long size);
extern spMp4MetaDataValueBox *spAppendMp4MetaDataBEUnsignedInt(spMp4MetaBox *meta, const char *type, unsigned long number, unsigned long size);
extern spMp4MetaDataValueBox *spAppendMp4MetaDataTempo(spMp4MetaBox *meta, long tempo);
extern spMp4MetaDataValueBox *spAppendMp4MetaDataBoolean(spMp4MetaBox *meta, const char *type, spBool flag);
extern spMp4MetaDataValueBox *spAppendMp4MetaDataGapless(spMp4MetaBox *meta, spBool flag);
extern spMp4MetaDataValueBox *spAppendMp4MetaDataCompilation(spMp4MetaBox *meta, spBool flag);
    
extern spBool spParseMp4MetaDataTrackNumber(spMp4MetaDataValueBox *databox, unsigned short *number, unsigned short *total);
extern spBool spParseMp4MetaDataDiscNumber(spMp4MetaDataValueBox *databox, unsigned short *number, unsigned short *total);
extern spBool spGetMp4MetaDataTrackNumber(spMp4MetaBox *meta, unsigned short *number, unsigned short *total);
extern spBool spGetMp4MetaDataDiscNumber(spMp4MetaBox *meta, unsigned short *number, unsigned short *total);
extern spMp4MetaDataValueBox *spAppendMp4MetaDataTrackNumber(spMp4MetaBox *meta, unsigned short number, unsigned short total);
extern spMp4MetaDataValueBox *spAppendMp4MetaDataDiscNumber(spMp4MetaBox *meta, unsigned short number, unsigned short total);

/* 'stsh' */
extern unsigned long spAppendMp4ShadowSyncSample(spMp4ShadowSyncSampleBox *stsh,
                                                 unsigned long shadowed_sample_number, unsigned long sync_sample_number);
    
/* 'stss' */
extern unsigned long spAppendMp4SyncSample(spMp4SyncSampleBox *stss, unsigned long sample);
    
/* 'stco' */
unsigned long spAppendMp4ChunkOffset(spMp4ChunkOffsetBox *stco, spFileOffset offset);
    
/* 'stsz' */
extern unsigned long spGetMp4SampleSize(spMp4SampleSizeBox *stsz, unsigned long sample); /* 'stsz' or 'stz2' */
extern spBool spSetMp4SampleSize(spMp4SampleSizeBox *stsz, unsigned long sample, unsigned long size);
extern unsigned long spAppendMp4SampleSize(spMp4SampleSizeBox *stsz, unsigned long size);
    
/* 'stsc' */
extern unsigned long spAppendMp4SampleToChunk(spMp4SampleToChunkBox *stsc,
                                              unsigned long chunk /* 1-based chunk */, unsigned long samples_per_chunk, unsigned long sample_description_index);
    
/* 'stts' */
extern unsigned long spGetMp4SampleDuration(spMp4TimeToSampleBox *stts, unsigned long sample);
extern unsigned long spGetMp4MaxSampleDuration(spMp4TimeToSampleBox *stts);
extern unsigned long spAppendMp4SampleDuration(spMp4TimeToSampleBox *stts, unsigned long sample, unsigned long sample_delta);

/* 'stsd' */
extern spMp4SampleEntryBox *spAppendMp4SampleDescriptionEntry(spMp4SampleDescriptionBox *stsd, const char *codingname, unsigned short data_reference_index);

/* 'vmhd' */
extern spMp4BoxSize spUpdateMp4VideoMediaHeaderBox(spMp4VideoMediaHeaderBox *vmhd, unsigned short graphicsmode, unsigned short opcolor[3]);
/* 'smhd' */
extern spMp4BoxSize spUpdateMp4SoundMediaHeaderBox(spMp4SoundMediaHeaderBox *smhd, unsigned short balance);
/* 'hmhd' */
extern spMp4BoxSize spUpdateMp4HintMediaHeaderBox(spMp4HintMediaHeaderBox *hmhd, unsigned short maxPDUSize, unsigned short avgPDUSize,
                                                  unsigned long maxBitRate, unsigned long avgBitRate);
    
/* 'keys' */
extern spMp4BoxSize spUpdateMp4KeysBox(spMp4KeysBox *keys, spMp4KeyEntry *entries, long count, spBool propagate_size);

/* 'hdlr' */
extern spMp4BoxSize spUpdateMp4HandlerReferenceBox(spMp4HandlerReferenceBox *hdlr, const char *handler_type, const char *name, spBool propagate_size);

/* 'mdhd' */
extern spMp4BoxSize spUpdateMp4MediaHeaderBoxV0(spMp4MediaHeaderBox *mdhd,
                                                time_t creation_time, time_t modification_time,
                                                unsigned long timescale, unsigned long duration,
                                                unsigned short language, unsigned short quality);
#ifdef SP_SUPPORT_64BIT_INT
extern spMp4BoxSize spUpdateMp4MediaHeaderBoxV1(spMp4MediaHeaderBox *mdhd,
                                                time_t creation_time, time_t modification_time,
                                                unsigned long timescale, spLong64 duration,
                                                unsigned short language, unsigned short quality);
#endif

/* 'dref' */
extern spMp4Box *spAppendMp4DataReferenceEntry(spMp4DataReferenceBox *dref, const char *type, const char *data, long size);
    
/* 'tref' */
extern spMp4BoxSize spUpdateMp4TrackReferenceBox(spMp4TrackReferenceBox *tref, const char *reference_type,
                                                 unsigned long *track_ids, long count, spBool propagate_size);
    
/* 'tkhd' */
extern spMp4BoxSize spUpdateMp4TrackHeaderBoxV0(spMp4TrackHeaderBox *tkhd, unsigned long flags,
                                                time_t creation_time, time_t modification_time,
                                                unsigned long track_id, unsigned long duration,
                                                short layer, short alternate_group, short volume, long matrix[9],
                                                unsigned long width, unsigned long height);
#ifdef SP_SUPPORT_64BIT_INT
extern spMp4BoxSize spUpdateMp4TrackHeaderBoxV1(spMp4TrackHeaderBox *tkhd, unsigned long flags,
                                                time_t creation_time, time_t modification_time,
                                                unsigned long track_id, spLong64 duration,
                                                short layer, short alternate_group, short volume, long matrix[9],
                                                unsigned long width, unsigned long height);
#endif
    
/* 'mvhd' */
extern spMp4BoxSize spUpdateMp4MovieHeaderBoxV0(spMp4MovieHeaderBox *mvhd,
                                                time_t creation_time, time_t modification_time,
                                                unsigned long timescale, unsigned long duration,
                                                long rate, short volume, long matrix[9], unsigned long next_track_id);
#ifdef SP_SUPPORT_64BIT_INT
extern spMp4BoxSize spUpdateMp4MovieHeaderBoxV1(spMp4MovieHeaderBox *mvhd,
                                                time_t creation_time, time_t modification_time,
                                                unsigned long timescale, spLong64 duration,
                                                long rate, short volume, long matrix[9], unsigned long next_track_id);
#endif
    
/* 'ftyp' */
extern spMp4BoxSize spUpdateMp4FileTypeBox(spMp4FileTypeBox *ftypbox, const char *major_brand, long minor_version,
                                           long nbrands, const char *compatible_brands);
    
extern void spPropagateMp4BoxContentSize(spMp4Box *parent, spChunkSize size_diff);
    
extern spMp4BoxSize spReadMp4Header(spMp4Header *header, FILE *fp);
extern spBool spFreeMp4Header(spMp4Header *header);
extern spBool spInitMp4HeaderWithCB(spMp4Header *header, spMp4BoxUpdateFunc update_func, void *data);
extern spBool spInitMp4Header(spMp4Header *header, const char *major_brand, long minor_version,
                              long nbrands, const char *compatible_brands);
    
extern spMp4BoxSize spWriteMp4Header(spMp4Header *header, spMp4BoxSize moov_size, spMp4Box **paused_box, FILE *fp);
extern spMp4BoxSize spRewriteMp4Header(spMp4Header *header, spMp4BoxSize mdat_size, spMp4Box **paused_box, FILE *fp);

extern spMp4BoxSize spCopyMp4Header(spMp4Header *dest_header, spMp4Header *src_header);
    
extern spMp4Box *spCreateMp4BoxWithCB(spMp4Box *parent, const char *type, spMp4BoxUpdateFunc update_func, void *data);
extern spMp4Box *spCreateMp4Box(spMp4Box *parent, const char *type);

extern spMp4Box *spFindMp4BoxFromHeader(spMp4Header *header, const char *type, const char *parent_type);
extern spMp4Box *spFindMp4Box(spMp4Box *box, const char *type, const char *parent_type);
extern spMp4TrackBox *spFindMp4TrackBox(spMp4Header *header, long index, const char *handler_type);
extern unsigned long spGetMp4MaxTrackId(spMp4Header *header);
extern spMp4SampleTableBox *spGetMp4TrackSampleTableBox(spMp4TrackBox *trak);
extern spMp4SampleEntryBox *spGetMp4TrackSampleEntryBox(spMp4TrackBox *trak, unsigned long index);

extern spMp4TrackBox *spAppendMp4SoundTrackBox(spMp4Header *header, unsigned long track_id,
                                               const char *codingname, unsigned short data_reference_index,
                                               unsigned short channelcount, unsigned short samplesize,
                                               short compression_id, double samplerate, char stz2_field_size, spBool co64_flag,
                                               spMp4BoxUpdateFunc update_func, void *data);
    
extern spFileOffset spGetMp4MdatContentOffset(spMp4Header *header);
extern unsigned long spConvertMp4TimeToSample(spMp4TimeToSampleBox *stts, spULong t, unsigned long *remainder);
extern unsigned long spConvertMp4ChunkToSample(spMp4SampleToChunkBox *stsc, unsigned long chunk /* 1-based */,
                                               unsigned long *samples_per_chunk, unsigned long *description_index);
/* returns 1-based index of the chunk */
extern unsigned long spConvertMp4SampleToChunk(spMp4SampleToChunkBox *stsc, unsigned long description_index, unsigned long sample, 
                                               unsigned long *remainder);
extern spFileOffset spConvertMp4SampleToFileOffset(spMp4SampleToChunkBox *stsc, unsigned long description_index, unsigned long sample, 
                                                   unsigned long *chunk, unsigned long *remainder, unsigned long *sample_size);
extern spMp4TrackBox *spFindMp4NextChunkFromFileOffset(spMp4Header *header, spFileOffset offset,
                                                       spFileOffset *o_offset, unsigned long *chunk /* 1-based */);

extern spBool spParseMp4SongInfo(spMp4MetaBox *meta, spSongInfoV2 *song_info);
extern spBool spAppendMp4SongInfo(spMp4MetaBox *meta, spSongInfoV2 *song_info);    
    
extern void spShowMp4HeaderInfo(spMp4Header *header);

extern void spConvMp4MatrixToDouble(long *imatrix, double *omatrix);
extern void spConvDoubleMatrixToMp4(double *imatrix, long *omatrix);
extern void spMultMp4MatrixToXY(long *matrix, long *x, long *y);
extern void spMultMp4MatrixToXYZ(long *matrix, long *x, long *y, long *z);

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration */
#endif

#endif /* __SPMP4_H */
