/*
 *        spWave_Caf.h
 *        
 *        **** UNOFFICIAL VERSION, DON'T USE THIS API ****
 */

#ifndef __SPWAVE_CAF_H
#define __SPWAVE_CAF_H

#include <sp/spChunk.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SP_SUPPORT_64BIT_INT

#define SP_CAF_MIN_ENTRY_ALLOC_COUNT 4
    
#define SP_CAF_SUPPORTED_FILE_VERSION 1
#define SP_CAF_SUPPORTED_FILE_FLAGS 0

#define SP_CAF_INFORMATION_KEY_TITLE "title"
#define SP_CAF_INFORMATION_KEY_ARTIST "artist"
#define SP_CAF_INFORMATION_KEY_ALBUM "album"
#define SP_CAF_INFORMATION_KEY_TRACK "track number"
#define SP_CAF_INFORMATION_KEY_RELEASE "year"
#define SP_CAF_INFORMATION_KEY_COMPOSER "composer"
#define SP_CAF_INFORMATION_KEY_LYRICIST "lyricist"
#define SP_CAF_INFORMATION_KEY_GENRE "genre"
#define SP_CAF_INFORMATION_KEY_COMMENT "comments"
#define SP_CAF_INFORMATION_KEY_COPYRIGHT "copyright"
#define SP_CAF_INFORMATION_KEY_SOFTWARE "encoding application"
#define SP_CAF_INFORMATION_KEY_TEMPO "tempo"

#define SP_CAF_INFORMATION_KEY_ALBUM_ARTIST "album artist" /* unofficial */
#define SP_CAF_INFORMATION_KEY_DISC "disc number" /* unofficial */
    
enum {
    SP_CAF_LPCM_FORMAT_FLAG_IS_FLOAT = (1 << 0),
    SP_CAF_LPCM_FORMAT_FLAG_IS_LITTLE_ENDIAN = (1 << 1),
};
#if BYTE_ORDER == BIG_ENDIAN
#define SP_CAF_LPCM_FORMAT_FLAG_IS_NATIVE_ENDIAN 0
#else
#define SP_CAF_LPCM_FORMAT_FLAG_IS_NATIVE_ENDIAN SP_CAF_LPCM_FORMAT_FLAG_IS_LITTLE_ENDIAN
#endif

enum {
    SP_CAF_ALAC_FORMAT_FLAG_16BIT_SOURCE_DATA = 1,
    SP_CAF_ALAC_FORMAT_FLAG_20BIT_SOURCE_DATA = 2,
    SP_CAF_ALAC_FORMAT_FLAG_24BIT_SOURCE_DATA = 3,
    SP_CAF_ALAC_FORMAT_FLAG_32BIT_SOURCE_DATA = 4,
};

typedef struct _spCafChunkHeader {
    char type[4];
    spLong64 mChunkSize;
    
    spLong64 mMarginSize;        /* internal */
} spCafChunkHeader;

typedef struct _spCafChunk {
    struct _spCafChunk *parent;
    struct _spCafChunk *child;
    
    struct _spCafChunk *prev;
    struct _spCafChunk *next;

    spFileOffset offset;
    
    spCafChunkHeader header;
} spCafChunk;

typedef struct _spCafAudioDescChunk {
    struct _spCafChunk *parent;
    struct _spCafChunk *child;
    
    struct _spCafChunk *prev;
    struct _spCafChunk *next;

    spFileOffset offset;
    
    spCafChunkHeader header;        /* 'desc' */

    double mSampleRate;
    char mFormatID[4];
    long mFormatFlags;
    long mBytesPerPacket;
    long mFramesPerPacket;
    long mChannelsPerFrame;
    long mBitsPerChannel;
} spCafAudioDescChunk;

typedef struct _spCafAudioDataChunk {
    struct _spCafChunk *parent;
    struct _spCafChunk *child;
    
    struct _spCafChunk *prev;
    struct _spCafChunk *next;

    spFileOffset offset;
    
    spCafChunkHeader header;        /* 'data' */

    long mEditCount;
    spLong64 mOffset;
} spCafAudioDataChunk;

typedef struct _spCafGeneralDataChunk {
    struct _spCafChunk *parent;
    struct _spCafChunk *child;
    
    struct _spCafChunk *prev;
    struct _spCafChunk *next;

    spFileOffset offset;
    
    spCafChunkHeader header;

    spBool allocFlag;
    char *mData;
} spCafGeneralDataChunk;

typedef struct _spCafChannelDescription {
    unsigned long mChannelLabel;
    unsigned long mChannelFlags;
    float mCoordinates[3];
} spCafChannelDescription;

typedef struct _spCafChannelLayoutChunk {
    struct _spCafChunk *parent;
    struct _spCafChunk *child;
    
    struct _spCafChunk *prev;
    struct _spCafChunk *next;

    spFileOffset offset;
    
    spCafChunkHeader header;        /* 'chan' */

    unsigned long mChannelLayoutTag;
    unsigned long mChannelBitmap;
    unsigned long mNumberChannelDescriptions;
    spCafChannelDescription *mChannelDescriptions;
} spCafChannelLayoutChunk;

typedef struct _spCafPacketTableChunk {
    struct _spCafChunk *parent;
    struct _spCafChunk *child;
    
    struct _spCafChunk *prev;
    struct _spCafChunk *next;

    spFileOffset offset;
    
    spCafChunkHeader header;        /* 'pakt' */

    spLong64 mNumberPackets;
    spLong64 mNumberValidFrames;
    long mPrimingFrames;
    long mRemainderFrames;

    spLong64 mBufferSize;
    char *mBuffer;
    
    spLong64 mTableSize;
    spLong64 *mTable;
} spCafPacketTableChunk;

typedef struct _spCafInformation {
    char *mKey;
    char *mValue;
} spCafInformation;
    
typedef struct _spCafInformationChunk {
    struct _spCafChunk *parent;
    struct _spCafChunk *child;
    
    struct _spCafChunk *prev;
    struct _spCafChunk *next;

    spFileOffset offset;
    
    spCafChunkHeader header;    /* 'info' */

    long mAllocCount;
    long mNumEntries;
    spCafInformation *mInformations;
} spCafInformationChunk;

typedef struct _spCafHeader {
    struct _spCafChunk *parent; /* NULL */
    struct _spCafChunk *child;  /* 'desc' */
    
    struct _spCafChunk *prev;   /* NULL */
    struct _spCafChunk *next;   /* NULL */

    spFileOffset offset;
    
    spCafChunkHeader header;    /* 'caff' */
    
    unsigned short mFileVersion;
    unsigned short mFileFlags;

    struct _spCafAudioDescChunk *desc;
    struct _spCafAudioDataChunk *data;
    
    struct _spCafPacketTableChunk *pakt;
    struct _spCafGeneralDataChunk *kuki;
} spCafHeader;

typedef spChunkSize (*spCafChunkUpdateFunc)(spCafChunk *chunk, void *data);
    
extern spBool spEqCafChunkType(spCafChunk *chunk, const char *type);

extern const char *spGetCafInformationValue(spCafInformationChunk *info, const char *key, long *index);
extern long spGetCafInformationValueInLocaleCode(spCafInformationChunk *info, const char *key, unsigned char *str_in_locale, long size);
    
extern spChunkSize spGetCafChunkContentMarginSize(spCafChunk *chunk);
extern spBool spSetCafChunkContentSize(spCafChunk *chunk, spChunkSize size);
extern spChunkSize spGetCafChunkSize(spCafChunk *chunk, char *string/* = char string[5] or NULL */);
extern spChunkSize spGetCafChunkContentSize(spCafChunk *chunk, char *string/* = char string[5] or NULL */);
    
extern spChunkSize spReadCafHeader(spCafHeader *header, FILE *fp);
extern spBool spFreeCafHeader(spCafHeader *header);

extern spChunkSize spWriteCafHeader(spCafHeader *header, FILE *fp);
extern spChunkSize spRewriteCafHeader(spCafHeader *header, long editCount, spLong64 dataSize, FILE *fp);
    
extern spChunkSize spCopyCafHeader(spCafHeader *dest_header, spCafHeader *src_header);
    
extern spBool spInitCafHeaderWithCB(spCafHeader *header, unsigned short fileVersion, unsigned short fileFlags,
                                    spCafChunkUpdateFunc update_func, void *data);
extern spBool spInitCafHeader(spCafHeader *header, unsigned short fileVersion, unsigned short fileFlags);
extern spBool spUpdateCafAudioDescChunk(spCafHeader *header, double sampleRate, const char *formatID,
                                        long formatFlags, long bytesPerPacket, long framesPerPacket,
                                        long channelsPerFrame, long bitsPerChannel); /* bitsPerChannel: of input data */
extern spBool spUpdateCafGeneralDataChunk(spCafHeader *header, const char *type, char *data, spLong64 size, spBool copy_flag);
extern spBool spUpdateCafPacketTableChunkForFixedFrame(spCafHeader *header, long packetMarginSize, spLong64 totalFrames, long *maxPacketSize);
extern spBool spUpdateCafPacketTableChunkNumberPackets(spCafHeader *header, spLong64 numberPackets, spLong64 totalFrames, spBool *insufficientBuffer);

extern spBool spUpdateCafAudioDataChunk(spCafHeader *header, long editCount, spLong64 dataSize);

extern spCafInformationChunk *spCreateCafInformationChunk(spCafHeader *header, spLong64 sizeWithFree);
extern spBool spUpdateCafInformationChunk(spCafInformationChunk *info, const char *key, const char *value);
extern spBool spUpdateCafInformationChunkFromLocaleCode(spCafInformationChunk *info, const char *key, const unsigned char *str_in_locale);
    
extern spBool spAppendCafInformationChunk(spCafHeader *header, const char *key, const char *value);
extern spBool spAppendCafInformationChunkFromLocaleCode(spCafHeader *header, const char *key, const unsigned char *str_in_locale);

extern spBool spParseCafSongInfo(spCafHeader *header, spSongInfoV2 *song_info);
extern spBool spAppendCafSongInfo(spCafHeader *header, spSongInfoV2 *song_info);
    
extern spCafChunk *spFindCafChunkFromHeader(spCafHeader *header, const char *type);
    
extern spFileOffset spConvertCafTimeToFileOffset(spCafHeader *header, spLong64 t,
                                                 long *packet, long *remainder, long *packet_frames);
extern spLong64 spGetCafTotalDuration(spCafHeader *header);
extern spLong64 spGetCafPacketSize(spCafHeader *header, long packet);
extern spBool spSetCafPacketSize(spCafHeader *header, long packet, spLong64 size);
extern spBool spSetCafFrameLength(spCafHeader *header, long packet, spLong64 length);

#endif
    
#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration */
#endif

#endif /* __SPWAVE_CAF_H */
